# encoding: UTF-8
module EpochHelper

  # Sestaví do pole strom accountů, každý account je reprezentován hashem s těmito atributy:
  #    :account_id  
  #    :id           css id account ve tvaru např. ak_1_2_1 kde čísla jsou indexy
  #    :indexes
  #    :level        úroveň zanoření
  #    :balance
  #    :popis
  #
  # @option :reverse_balance     reverse sign of balances
  # @option :skip_zero_balance   skip account with zero balance
  def tree(accounts,epoch,prefix,options={})
    roots = 0
    tree = Account.construct_tree_array(accounts).collect do |item| # predpokladam ze jsou accounty usporadany v "hierarchickem poradi"
      item[:account_id]= item[:account].id
      item[:level]=item[:indexes].size
      item[:balance] = item[:account].balance3(:epoch=>epoch, :only_proper_splits=>item[:only_proper_balance])
      item[:balance] = -item[:balance] if options[:reverse_sign]
      roots += 1 if item[:level]==1
      item
    end
    tree.each do |item|
      item[:popis]= item[:account].
        popis_without([item[:parent].andand.popis]) # + item[:account].owner_accounts.collect{|o| o.popis})
    end
    # pokud je jenom jeden root tak vše o level posunout a na konec dát "ostatní"
    if roots==1 and tree.size>1
      tree.each do |i|
        i[:level]+= -1
        i[:popis]=i[:account].popis_without(tree.first[:account].popis)
        i[:indexes].delete_at(0)
      end
      tree.first[:has_children]=false
      tree.first[:only_proper_balance]=true
      tree.first[:popis] = 'ostatní' if tree.first[:popis].blank?
      tree.first[:level] = 1
      tree.first[:indexes] = tree.last[:indexes].clone
      tree.first[:indexes][-1] += 1
      tree.push(tree.first)
      tree.delete_at(0)
    end
    # promazat zero balance a přepočítat indexy
#     if options[:skip_zero_balance]
#       tree.each do |item|
#         if item[:balance] != {} 
#           #([prefix] + item[:indexes]).join('_')
#         end
#       end
#     end
    # vyplnit idčka
    tree.each do |item|
      item[:id]=([prefix] + item[:indexes]).join('_')
    end
    tree
  end

end